Subject: Re: sendfile()? Re: SO_LINGER dead: I get an immediate RST on 2.6.24?

From: Rick Jones <[email-masked]>
Date: Wed, 14 Jan 2009 00:08:42 -0800

>>How likely is it that the "additional small delay" above would be much 
>>less than waiting for a read return of zero after a shutdown(SHUT_WR) call?
> 
> 
> I'm not sure I understand what you're getting at.  I did consider doing
> something like what you suggested, but in the end decided it was simpler
> to deal with a fully ESTABLISHED connection, than worrying about possible
> races with a socket being (partially or fully) closed.

Ostensibly, using a shutdown(SHUT_WR) and then a wait for a recv return 
of zero would take about the same length of time as polling local 
connection stats to see that there were no ostensibly unacked data - 
both will take one RTT right?  and shutdown/read has the added property 
that it will deal with zero windows automagically.

rick